class WordItem extends SimpleMapItem {
  int z;
  String word;
  
  DeweyCategory dewey; 
  
  float d;
  Random random1;
  WordItem(String word, int deweyCode) {
    this.dewey = (DeweyCategory) Deweys.get(deweyCode);
    this.word = word;
    this.z = 0;
    
  }
  void draw( ) {
    this.d = map(this.dewey.numberCheckouts[monthCounter], _minCheckout[monthCounter], _maxCheckout[monthCounter], 100, 500 );
   
    //println("Drawing "+this.dewey.deweyCode);
    //println(x+" "+y+" "+w+" "+h+" "+" "+d);
    pushMatrix();
    
    noFill();
    //noStroke();
    strokeWeight(2);
    stroke(0,36,54,100);
    translate(x+w/2,y+h/2,0);
    translate(0,0,d/2); //added by josh.  You want everything to start on the same z-axis line so your first translation needs to have a z-axis value that's proportional to your box's overall height.   
    box(w,h,d);
    
    pushMatrix();
    translate(0,0,-d*0.55); //added by josh.  I'm not sure why it's -5.5 and not just -5... but it seems to line up now.  
    for(int i = 0; i<10; i++){
    
      //stroke(0,50,10,100);
      noStroke();
      noFill();
      translate(0,0,d/10);
      box(w,h,d/10);
     
      pushMatrix();
      translate(-w*0.515,0,0);
      for(int j=0; j<31; j++){
        
        noStroke();
        float colorS = map(this.dewey.getDataElement(i, monthCounter, j), _min[monthCounter], _max[monthCounter], 10, 100);
        float colorH = map(this.dewey.getDataElement(i, monthCounter, j), _min[monthCounter], _max[monthCounter], 0, 360);
        float colorV = map(this.dewey.getDataElement(i, monthCounter, j), _min[monthCounter], _max[monthCounter], 10, 100);
        
        //if(colorS < 30)
        //  colorS = colorS + 20;
        if(mode == 0)
          fill(0,100,colorS,100);
        else if (mode == 1)
          fill(colorH,0,colorS,100);
        else
          fill(colorH,100,colorS,100);
        
        //fill(0,100, random1.nextInt(100), 100);
        translate(w/31,0,0);
        box(w/31, h, d/10);        
      }
      popMatrix();
      /*
      pushMatrix();
      translate(-w/2,h/2,z);      
      rotateX(-PI/2);
      fill(0,0,100,100);
      PFont font = createFont("MyriadPro-Regular", 8);
      textFont(font);
      textAlign(LEFT, BOTTOM);
      text(i, 0, 0);
      popMatrix();
      */
    }
    pushMatrix();
      translate(-w/2, h/2, -d); 
      rotateX(-PI/2);
      fill(0,0,100,100);
      PFont font = createFont("MyriadPro-Regular", 8);
      textFont(font);
      textAlign(LEFT, CENTER);
      int temp = 0;
      if(this.dewey.deweyCode == 700)
        temp = 20;
      
      text(this.dewey.deweyCode, 0, 0-temp);      
      text(this.dewey.deweyCode+100, 0, -d-10-temp);      
   popMatrix();
   
   pushMatrix();
      rotateZ(-PI/2);
      translate(-w/2,h/2,d/8);
      font = createFont("MyriadPro-Regular", 25);
      textFont(font);
      textAlign(CENTER, CENTER);
      text(this.dewey.deweyName, -w/2+150, -h/2);
   popMatrix();
   
   /*pushMatrix();   
      translate(-w/2,h/2, -d);
      rotateX(-PI/2);
      fill(0,0,100,100);
      textAlign(LEFT, CENTER);
      text(this.dewey.deweyCode+100, 0, 0);
    popMatrix();
    */  
    popMatrix();

    
    popMatrix();

    fill(255);
    rectMode(CORNER);
    //rect(x, y, w, h);    
    fill(255);
    

  }
}

