class WordItem extends SimpleMapItem {
  int z;
  String word;
  float d;
  Random random1;
  WordItem(String word) {
    this.word = word;
    z = 0;
    d = textWidth(this.word)*10;
    random1 = new Random();
  }
  void draw( ) {
    pushMatrix();
    noFill();
    stroke(0,0,100,100);
    translate(x,y,0);
    translate(0,0,d/2); //added by josh.  You want everything to start on the same z-axis line so your first translation needs to have a z-axis value that's proportional to your box's overall height.   
    box(w,h,d);
    
    pushMatrix();
    translate(0,0,-d*0.55); //added by josh.  I'm not sure why it's -5.5 and not just -5... but it seems to line up now.  
    for(int i = 0; i<10; i++){
    
      if(i%2==0){
        stroke(0,100,100,100);
        //fill(0,100,100,2);
      }
      else{
        stroke(120,100,100,100);
        //fill(120,100,100,2);
      }
      
      translate(0,0,d/10);
      box(w,h,d/10);
     
      pushMatrix();
      translate(-w*0.515,0,0);
      for(int j=0; j<31; j++){
        /*
        if(j%2==0){
          stroke(180,100,100,100);
          fill(180,100,100,100);
        }
        else{
          stroke(240,100,100,100);
          fill(240,100,100,100);
        }*/
        
        fill(0,100, random1.nextInt(100), 100);
        translate(w/31,0,0);
        box(w/31, h, d/10);
      }
      popMatrix();
      
    }
    popMatrix();
      
    if (w > textWidth(word) + 6) {
      if (h > textAscent( ) + 6) {
        textAlign(CENTER, CENTER);
        text(word, 0, 0);
      }
    }
    popMatrix();

    fill(255);
    rectMode(CORNER);
    //rect(x, y, w, h);    
    fill(255);
    

  }
}

