/*

Query to get Day wise data for all months, deweys and sub-deweys

select FLOOR(deweyClass/100)*100 dewey, FLOOR(deweyClass/10)*10 deweySub, month(cout) month, day(cout) day, count(*)
from spl0.inraw
where
(deweyClass <> 'null' OR deweyClass <> NULL)
and year(cout) = 2011
group by dewey, deweySub, month, day 
order by dewey, deweySub, month, day;

Query to get Average Checkout Duration and Number of Checkouts per month for eacch Dewey Category.
select FLOOR(deweyClass/100)*100 dewey, month(cout) month, count(*), avg(TIMESTAMPDIFF(DAY, cout, cin))
from spl0.inraw
where
(deweyClass <> 'null' OR deweyClass <> NULL)
and year(cout) = 2011
group by dewey, month 
order by dewey, month;






























*/
